\ ------------------------------------------
\ ***** Csg.f ***** (Complete String Gadget)
\ ------------------------------------------
{  TBG.f and CSG.f Version 1.0
   Text Boolean Gadgets and String/Integer gadget creation helper.

   by Marc Lupien,  Montreal, Canada.
   June of 1988
   CIS user no. 71550,640
}
{
Easy allocation and initialisation for String and Integer gadgets.

  No syntax checking is done when you define your gadgets.  The gadget
created, identified by <name> further, actually returns the address of a
gadget structure.

  I wanted this to be as flexible as possible.  You should find everything
you need here for normal string/integer gadgets. If you need to define your
gadgets is some other ways, you should be able to create new words to use
beteewn StringGadget and EndStringGadget to suit your needs.  Jump right
in.


NOTE :	The following  words use R! and R, to implement relocation.
   Follow these relocation words instructions to run-time-init your
gadgets.

To Allocate and compile-time-init a String Gadget :

   StringGadget <name>
	<TopEdge> <LeftEdge> <ID>	setTop\Left\ID
	<ShownSize> <FullSize>		StringGadgetSize
	[ FrontLabel" <text>" ]
	[ <BorderDefiningWord> ]
   EndStringGadget

To Allocate and compile-time-init a Integer Gadget :

   IntegerGadget <name>
	<TopEdge> <LeftEdge> <ID>	setTop\Left\ID
	<Size>	IntegerGadgetSize
	[ FrontLabel" <text>" ]
	[ <BorderDefiningWord> ]
   EndIntegerGadget

   <ID>		: is the gadget-ID you want to give your gadget
   <TopEdge>	: Top edge position of the gadget
   <LeftEdge>	: Left edge position of the gadget
   <ShownSize>	: nb. of chars that will fit in the box on screen
   <FullSize>	: total nb. of chars that fits into the string buffer
   <Size>	: nb. of digits that will fit in the box on screen
   <name>	: choose a name for your gadget
   <text>	: an identifying text ending with a quote
   <BorderDefiningWord> : one of the predefined border designing word that
		  will create a border to fit your gadget.
   
}


Find GDefault_F not Iftrue include GDefault.f  Ifend

cr ." loading Csg.f..." cr  decimal

anew CSG_F

\ --------------------------------------------------------
\ Common Undo buffer for all String and Integer gadgets...
\ --------------------------------------------------------

  80 constant MaxCsgBufferSize

  create CsgUndoBuffer MaxCsgBufferSize 1+ allot


\ ---------------------------------------------
\ difference between String and Integer gadget.
\ ---------------------------------------------

   GADGHCOMP RELVERIFY |	constant CSG.ggActivation ( for string)

   GADGHCOMP RELVERIFY | STRINGRIGHT | LONGINT |
				constant CIG.ggActivation ( for integer)

\ ------------------------------------------------------------
\ Create a StringGadget or IntegerGadget
\ ------------------------------------------------------------
	
: StringGadget    ( -- GadgetStructAddrs ) ( <name> )
     CSG.ggActivation STRGADGET CreateGadget ; immediate

: IntegerGadget   ( -- GadgetStructAddrs ) ( <name> )
     CIG.ggActivation STRGADGET CreateGadget ; immediate


\ type = 0 for string gadget, 1 for integer...

: <siGadgetSize>   ( Gadget\ShownSize\FullSize\type -- Gadget )
	4 needed ?exec		\ check stack depth and exec state
	0 0 locals| siAddr BuffAddr type FullSize ShownSize Gstruct |

	FullSize MaxCsgBufferSize > ShownSize FullSize > or
	if cr ." ERROR! ShownSize exceed FullSize or FullSize exceeds "
	   MaxCsgBufferSize .
	   0 0 error
	then
	ShownSize myFontWidth *	Gstruct +ggWidth  w!
	myFontHeight		Gstruct +ggHeight w!
	FullSize 1+ AllotStringInfo to siAddr	\ allot StringInfo struct
	FullSize 1+ AllotStruct to BuffAddr	\ allot Buffer
	BuffAddr CsgUndoBuffer siAddr R!siBuffers \ set buffers address
	siAddr Gstruct +ggSpecialInfo R!	\ set string info addr
	Gstruct ;


: StringGadgetSize   ( Gadget\ShownSize\FullSize -- Gadget )
	0 <siGadgetSize> ; immediate

: IntegerGadgetSize   ( Gadget\Size -- Gadget )
	dup 1 <siGadgetSize> ; immediate

axe <siGadgetSize>


: FrontLabel"   ( Gadget -- Gadget ) ( <text>" )
	1 needed ?exec		\ check stack and exec state
	0 0 locals| ITLen ITstruct Gstruct |
	1 AllotIntuiText to ITstruct		\ front pen = 1
	ITstruct AllotIText" to ITLen		\ get <text>"
	ITlen 1+ myFontWidth * negate
	      ITstruct +itLeftEdge w!		\ put it in front
	ITstruct Gstruct +ggGadgetText R!	\ link text to gadget
	Gstruct ; immediate


: EndStringGadget   ( Gadget -- )
	1 needed ?exec
	drop ; immediate	\ get rid of gadget address...

: EndIntegerGadget   ( Gadget -- )
	[compile] EndStringGadget ; immediate

