\ ShadowText.f

{  TBG.f and CSG.f Version 1.0
   Text Boolean Gadgets and String/Integer gadget creation helper.

   by Marc Lupien,  Montreal, Canada.
   June of 1988
   CIS user no. 71550,640

  For use with files TBG.f and CSG.f

  Creates a shadow for the IntuiText in the specified gadget
  by creating a second occurence of IntuiText pointing to the
  same string as the first TntuiText but with different FrontPen
  and slightly shifted Top and Left Edges...

  This word should typically be used just after either
  Frontlabel" or BoolGadgetText" to modify the IntuiText structure
  created by one of them.

  It serves mostly as an example of UPGRADE that can be done to this
  basic package to create very personnal gadgets...
}

: ShadowText   ( GadgetStruct -- GadgetStruct )
	1 needed ?exec		\ check stack and exec state
	dup +ggGadgetText @	\ get previous IntuiText structure
	0 locals| ITstruct2 ITstruct1 Gstruct |
	ITstruct1 0=
	   error" ERROR!!! gadget does not have any text defined..."
	myHighlightPen AllotIntuiText to ITstruct2
	\ shift shadow by 1 pixel right and down
	ITstruct1 +itTopEdge  w@ 1+ ITstruct2 +itTopEdge  w!
	ITstruct1 +itLeftEdge w@ 1+ ITstruct2 +itLeftEdge w!
	ITstruct1 +itIText     @    ITstruct2 +itIText R!
	\ note: in next statement I DO NOT use R! because that
	\ location is already marked for relocaion...
	ITstruct2 Gstruct +ggGadgetText !	\ link shadow first
	ITstruct1 ITstruct2 +itNextText R!	\ link main after
	Gstruct ; immediate

