\ ------------------------------------------
\ ***** Tbg.f ***** (Text Boolean Gadget)
\ ------------------------------------------
{  TBG.f and CSG.f Version 1.0
   Text Boolean Gadgets and String/Integer gadget creation helper.

   by Marc Lupien,  Montreal, Canada.
   June of 1988
   CIS user no. 71550,640
}
{
Easy allocation and initialisation Text-filled Boolean Gadget.

  No syntax checking is done when you define your gadgets.  The gadget
created, identified by <name> further, actually returns the address of a
gadget structure.

  I wanted this to be as flexible as possible.  You should find everything
you need here for normal string/integer gadgets. If you need to define your
gadgets is some other ways, you should be able to create new words to use
beteewn TextBoolGadget and EndBoolGadget to suit your needs.  Jump right
in.


NOTE :	The following  words use R! and R, to implement relocation.
   Follow these relocation words instructions to run-time-init your
gadgets.

To Allocate and compile-time-init a Text Boolean Gadget :

   TextBoolGadget <name>
	<TopEdge> <LeftEdge> <ID>   setTop\Left\ID
	BoolGadgetText" <Text>"
	[ ToggleSelectStyle ]
	[ <BorderDefiningWord> ]
   EndBoolGadget

   <ID>		: is the gadget-ID you want to give your gadget
   <TopEdge>	: Top edge position of the gadget
   <LeftEdge>	: Left edge position of the gadget
   <Text>	: The text you want to put inside your gadget
   <name>	: choose a name for your gadget
   <BorderDefiningWord> : one of the predefined border designing word that
		  will create a border to fit your gadget.

}
Find GDefault_F not
Iftrue
	include GDefault.f
Ifend

cr ." loading Tbg.f..." cr  decimal

anew TBG_F

\ ------------------------------------------------------------
\ Create a TextBoolGadget
\ ------------------------------------------------------------


	GADGHCOMP RELVERIFY |	constant TBG.ggActivation

: TextBoolGadget   ( -- GadgetStructAddrs ) ( <name> )
	TBG.ggActivation BOOLGADGET CreateGadget ; immediate

: BoolGadgetText"   ( Gadget -- Gadget ) ( <text>" )
	1 needed ?exec		\ check stack and exec state
	0 0 locals| ITLen ITstruct Gstruct |
	myFrontPen AllotIntuiText to ITstruct
	2 ITstruct +itTopEdge w!		\ slack between border
	ITstruct AllotIText" dup to ITLen	\ get <text>"
	myFontWidth *   Gstruct +ggWidth  w!	\ Select Box Width
	myFontHeight 4+ Gstruct +ggHeight w!	\ Select Box Height
	ITstruct Gstruct +ggGadgetText R!	\ link text to gadget
	Gstruct ; immediate

: ToggleSelectStyle   ( Gadget -- Gadget )
	1 needed ?exec
	dup  RELVERIFY TOGGLESELECT |  swap +ggActivation w!
	; immediate

: EndBoolGadget   ( Gadget -- )
	1 needed ?exec
	drop ; immediate	\ get rid of gadget address
